com.avaya.ccs.api

## Interface MonitoredInteractionListenerI

-     public interface MonitoredInteractionListenerI

  An implementing instance of the `MonitoredInteractionListenerI` interface delivers `MonitoredInteractionI` level events to the application.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `onMonitoredInteractionEvent(NotificationEventI<MonitoredInteractionI> monitoredInteractionEvent)` This method delivers a `NotificationEventI` object which contains a `NotificationType`, the object that is being updated (`MonitoredInteractionI`), an optional `ErrorI` object and an optional `ResponseData` object.

- - ### Method Detail

    - #### onMonitoredInteractionEvent

          void onMonitoredInteractionEvent(NotificationEventI<MonitoredInteractionI> monitoredInteractionEvent)

      This method delivers a `NotificationEventI` object which contains a `NotificationType`, the object that is being updated (`MonitoredInteractionI`), an optional `ErrorI` object and an optional `ResponseData` object.

      A `NotificationType.NEW` notification indicates that a new `MonitoredInteractionI` object has been created and is available via `MonitoredUserI.getMonitoredInteractions()` if required. A `NotificationType.UPDATE` notification indicates that properties of the specified `MonitoredInteractionI` instance has been modified and the newly supplied `MonitoredInteractionI` object represents a complete update of the object.

      A `NotificationType.DELETE` notification indicates that the `InteractionI` represented by the `MonitoredInteractionI` object has been deleted. The majority of API methods will throw an `ObjectInvalidException` if invoked after the `MonitoredInteractionI` object has been deleted. However a small set of API methods for retrieving specific properties are available for the client application after the `MonitoredInteractionI` object has been deleted. If an API method is accessible after object deletion it will be specified in the API documentation. The client application must discontinue use of the identified `MonitoredInteractionI` object and must null out all references it holds to the deleted `MonitoredInteractionI` object. This is to ensure that garbage collection of the deleted objects can occur. The `MonitoredInteractionI` object will also be removed from the list returned by `MonitoredUserI#getMonitoredInteractions`.

      An `NotificationType.ERROR` notification indicates the failure of a `MonitoredInteractionI` method call made by the client application on the specified `MonitoredInteractionI` instance. The accompanying `ErrorI` object provides details as to the cause of the error. A `NotificationType.RESPONSE` notification indicates that a response has been received for an `MonitoredInteractionI` method that has requested data from the server. The response notifications will have a `ResponseData` object containing the data that was requested.

      The CCS API executes this event listener method in the context of the CCS API processing threads. On receiving a notification event, the application must immediately switch executing context from the CCS API processing threads and move processing of the event to application threads.

      Parameters:
        `monitoredInteractionEvent` - an event containing a `MonitoredInteractionI` notification